Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class ExecutableFunctionLibrary

    java.lang.Object
      net.sf.saxon.functions.ExecutableFunctionLibrary

All Implemented Interfaces:
  Serializable, FunctionLibrary

    public class ExecutableFunctionLibrary

extends Object
implements FunctionLibrary

An ExecutableFunctionLibrary is a function library that contains definitions of functions for use at run-time. Normally functions are bound at compile-time; however there are various situations in which the information is needed dynamically, for example (a) to support the XSLT function-available() call (in the pathological case where the argument is not known statically), (b) to allow functions to be called from saxon:evaluate(), (c) to allow functions to be called from a debugging breakpoint. The objects actually held in the ExecutableFunctionLibrary are UserFunctionCall objects that have been prepared at compile time. These are function calls that do full dynamic type checking: that is, they are prepared on the basis that the static types of the arguments are all "item()*", meaning that full type checking is needed at run-time.

See Also:
  Serialized Form

Constructor Summary
`ExecutableFunctionLibrary(Configuration config)` Create the ExecutableFunctionLibrary

Method Summary
`void` | `addFunction(UserFunction fn)` Register a function with the function library
`Expression` | `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env, Container container)` Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`SequenceType[]` | `getFunctionSignature(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available; if so, return its signature.
`Iterator<UserFunction>` | `iterateFunctions()` Iterate over all the functions defined in this function library.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ExecutableFunctionLibrary

    public ExecutableFunctionLibrary(Configuration config)

  Create the ExecutableFunctionLibrary

  Parameters:
    `config` - the Saxon configuration

Method Detail

### addFunction

    public void addFunction(UserFunction fn)

  Register a function with the function library

  Parameters:
    `fn` - the function to be registered

### getFunctionSignature

    public SequenceType[] getFunctionSignature(StructuredQName functionName,
                                               int arity)

  Test whether a function with a given name and arity is available; if so, return its signature. This supports the function-available() function in XSLT; it is also used to support higher-order functions introduced in XQuery 1.1.

  This method may be called either at compile time or at run time. If the function library is to be used only in an XQuery or free-standing XPath environment, this method may throw an UnsupportedOperationException.

  Specified by:
    `getFunctionSignature` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the qualified name of the function being called
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some function of this name available for calling.
  Returns:
    if a function of this name and arity is available for calling, then the type signature of the function, as an array of sequence types in which the zeroth entry represents the return type; or a zero-length array if the function exists but the signature is not known; or null if the function does not exist

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env,
                           Container container)
                    throws XPathException

  Bind a function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` - The name of the function to be called
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
    `env` - the static evaluation context
    `container` -
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function; or if this function library "owns" the namespace containing the function call, but no function was found.

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

### iterateFunctions

    public Iterator<UserFunction> iterateFunctions()

  Iterate over all the functions defined in this function library. The objects returned by the iterator are of class `UserFunction`

  Returns:
    an iterator delivering the `UserFunction` objects representing the user-defined functions in a stylesheet or query

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.